package  rsf.operator;

import   rsf.vector.*;
import   juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ElwInvTest {
  public static void main(String[] argv) {

    boolean correct = true;

    int[] nn  = {5,3,2};
    Rsf data  = RsfFactory.newRsf(nn);
    data.fill(2.f);
    int[] loc = {0,0,0};
    data.setDatum(loc,1e-15f);

    System.out.println(data);

    // uses the static main routine 
    ElwInv.elwInv(data, 1.0e-12f); 

    float[][][] x = ((Rsf3) data).d;
    for(int i2=1; i2<nn[2]; i2++) {
    for(int i1=1; i1<nn[1]; i1++) {
    for(int i0=1; i0<nn[0]; i0++) {
      if (x[i2][i1][i0] != 0.5f   ) correct = false;
    }}}

    if   (x[0][0][0]    != 1.0e12f) correct = false;

    System.out.println("The next array elements are the inverse of ");
    System.out.println("the elements above (except the first element):"); 
    System.out.println(data);

    // uses the operator entry 
    ElwInv myInvOp = new ElwInv((RsfSpace) data.getSpace(), 
			  java.lang.Float.MIN_VALUE); 
    Rsf result = (Rsf) myInvOp.getRange().newMember();
    x[1][2][4] = 0f; 
    result = (Rsf) myInvOp.image(data); 

    float[][][] y = ((Rsf3) result).d;
    for(int i2=1; i2<nn[2]  ; i2++) {
    for(int i1=1; i1<nn[1]  ; i1++) {
    for(int i0=1; i0<nn[0]-1; i0++) {
      if (y[i2][i1][i0] != 2.0f   ) correct = false;
    }}}

    if   (y[0][0][0]    != 1.0e-12f) correct = false;
    if   (y[1][2][4]    != java.lang.Float.POSITIVE_INFINITY) correct = false;


    System.out.println(
        "The next array elements are the same as the original one \n" + 
        "(except the first and last element):"); 
    System.out.println(result);

    // The third entry is using the main routine 

    Tester.exit(correct);
  }
}

