package  rsf.operator;

import   jam.vector.*;
import 	 rsf.vector.*;
import   sep.io.ArgumentKeeper;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * Computes a to the power of b of the Rsf's elements.
 */
public class ElwPow implements jam.operator.Operator {
  RsfSpace spc; 
  double   exp; 

  public ElwPow(Space spc, float exp) {
    this(spc, (double) exp); 
  }
  public ElwPow(Space spc, double exp) {
    this.spc = (RsfSpace) spc;
    this.exp = exp; 
  }

  // operator superclass methods

  public jam.JamObject copy  () { return new ElwPow(spc,exp); }

  public Vector image(Vector d) {
    Vector r = getRange().newMember();
    elwPow(false,r,d,exp);
    return r;
  }
  public void image(Vector d, Vector r){
    elwPow(false,r,d,exp);
  }
  /** 
   * I wonder if this method makes any sense for Pow(). I could 
   * throw an error instead. 
   */
  public void addImage(Vector d, Vector r){ 
    elwPow(true,r,d,exp);
  } 
  public void residual(Vector d, Vector b, Vector r) {
    r.neg(b);
    addImage(d,r); 
  }

  public  Space getDomain         () { return spc; }
  public  Space getRange          () { return spc; }

  /**
   * invocations: o = i**0.5 \br
   * ElwPow < i.H exp=0.5 > o.H
   */
  public static void main(String[] args) { 
    Rsf data = RsfFactory.newRsf(System.in);
    ArgumentKeeper argKeeper = new ArgumentKeeper(args);
    double exp               = argKeeper.getDouble("exp","");
    elwPow(false,data,data,exp); 
    data.write(System.out); 
  }
  public static void elwPow(Rsf v, double exp) {
    elwPow(false, v, v, exp);
  }

  public static void elwPow(boolean add, Vector r, Vector d, double exp) {
    elwPow(add, (Rsf) r, (Rsf) d, exp);
  }

  public static void elwPow(boolean add, Rsf r, Rsf d, double exp) {
    int[] dd = ((RsfSpace) d.getSpace()).getNSamples();
    int[] rr = ((RsfSpace) r.getSpace()).getNSamples();

    if (! juice.util.JuiceUtil.equalArrays(dd, rr) ){
      System.err.println(
	 "Error: elementwise operation requires equal array size!");
    }

    switch (dd.length) {
    case 1: 
      float[] r0 = ((Rsf1) r).d;
      float[] d0 = ((Rsf1) d).d;
      for (int i0=0; i0<dd[0]; i0++) {
	if (add) 
	  r0[i0]         += (float) Math.pow(d0[i0],exp);
	else 
	  r0[i0]          = (float) Math.pow(d0[i0],exp);
      }
      break;
    case 2: 
      float[][] r1 = ((Rsf2) r).d;
      float[][] d1 = ((Rsf2) d).d;
      for (int i1=0; i1<dd[1]; i1++) {
      for (int i0=0; i0<dd[0]; i0++) {
	if (add) 
	  r1[i1][i0]     += (float) Math.pow(d1[i1][i0],exp);
	else 
	  r1[i1][i0]      = (float) Math.pow(d1[i1][i0],exp);
      }}
      break;
    case 3:
      float[][][] r2 = ((Rsf3) r).d;
      float[][][] d2 = ((Rsf3) d).d;
      for (int i2=0; i2<dd[2]; i2++) {
      for (int i1=0; i1<dd[1]; i1++) {
      for (int i0=0; i0<dd[0]; i0++) {
	if (add) 
	  r2[i2][i1][i0] += (float) Math.pow(d2[i2][i1][i0],exp);
	else 
	  r2[i2][i1][i0]  = (float) Math.pow(d2[i2][i1][i0],exp);
      }}}
      break;
    }
  }
}







