package  rsf.operator;

import   jam.vector.*;
import 	 rsf.vector.*;
import   sep.io.ArgumentKeeper;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * Computes a to the square root of the Rsf's elements.
 */
public class ElwSqrt implements jam.operator.Operator {
  RsfSpace spc; 

  public ElwSqrt(Space spc) {
    this.spc = (RsfSpace) spc;
  }

  // operator superclass methods

  public jam.JamObject copy  () { return new ElwSqrt(spc); }

  public Vector image(Vector d) {
    Vector r = getRange().newMember();
    elwSqrt(r,d);
    return r;
  }
  public void image(Vector d, Vector r){
    elwSqrt(r,d);
  }
  /** 
   * I wonder if this method makes any sense for Pow(). I could 
   * throw an error instead. 
   */
  public void addImage(Vector d, Vector r){ 
    elwSqrt(true,r,d);
  } 
  public void residual(Vector d, Vector b, Vector r) {
    r.neg(b);
    addImage(d,r); 
  }

  public  Space getDomain         () { return spc; }
  public  Space getRange          () { return spc; }

  /**
   * Usage:<br>
   * ElwSqrt < i.H > o.H
   */
  public static void main(String[] args) { 
    Rsf data = RsfFactory.newRsf(System.in);
    ArgumentKeeper argKeeper = new ArgumentKeeper(args);
    elwSqrt(data,data); 
    data.write(System.out); 
  }
  public static void elwSqrt(Vector r, Vector d) {
    elwSqrt(false, (Rsf) r, (Rsf) d);
  }
  public static void elwSqrt(boolean add, Vector r, Vector d) {
    elwSqrt(add, (Rsf) r, (Rsf) d);
  }
  public static void elwSqrt(Rsf rd) {
    elwSqrt(false, rd, rd); 
  }
  public static void elwSqrt(Rsf r, Rsf d) {
    elwSqrt(false, r, d); 
  }
  public static void elwSqrt(boolean add, Rsf r, Rsf d) {
    int[] dd = ((RsfSpace) d.getSpace()).getNSamples();
    int[] rr = ((RsfSpace) r.getSpace()).getNSamples();

    if (! juice.util.JuiceUtil.equalArrays(dd, rr) ){
      System.err.println(
	 "Error: elementwise operation requires equal array size!");
    }

    switch (dd.length) {
    case 1: 
      float[] r0 = ((Rsf1) r).d;
      float[] d0 = ((Rsf1) d).d;
      for (int i0=0; i0<dd[0]; i0++) {
	if (add) 
	  r0[i0]         += (float) Math.sqrt(d0[i0]);
	else 
	  r0[i0]          = (float) Math.sqrt(d0[i0]);
      }
      break;
    case 2: 
      float[][] r1 = ((Rsf2) r).d;
      float[][] d1 = ((Rsf2) d).d;
      for (int i1=0; i1<dd[1]; i1++) {
      for (int i0=0; i0<dd[0]; i0++) {
	if (add) 
	  r1[i1][i0]     += (float) Math.sqrt(d1[i1][i0]);
	else 
	  r1[i1][i0]      = (float) Math.sqrt(d1[i1][i0]);
      }}
      break;
    case 3:
      float[][][] r2 = ((Rsf3) r).d;
      float[][][] d2 = ((Rsf3) d).d;
      for (int i2=0; i2<dd[2]; i2++) {
      for (int i1=0; i1<dd[1]; i1++) {
      for (int i0=0; i0<dd[0]; i0++) {
	if (add) 
	  r2[i2][i1][i0] += (float) Math.sqrt(d2[i2][i1][i0]);
	else 
	  r2[i2][i1][i0]  = (float) Math.sqrt(d2[i2][i1][i0]);
      }}}
      break;
    }
  }
}


