package  rsf.operator;

import   rsf.vector.*;
import   juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ElwSqrtTest {
  public static void main(String[] argv) {

    boolean correct = true;

    int[] nn = {5,3,2};
    Rsf data = RsfFactory.newRsf(nn);
    Rsf rslt = RsfFactory.newRsf(nn);
    data.fill(4.0f);

    System.out.println(data);

    // uses the static main routine 
    ElwSqrt.elwSqrt(rslt, data); 

    float[][][] x = ((Rsf3) rslt).d;
    for(int i2=0; i2<nn[2]; i2++) {
    for(int i1=0; i1<nn[1]; i1++) {
    for(int i0=0; i0<nn[0]; i0++) {
      if (x[i2][i1][i0] != 2.0f) correct = false;
    }}}

    System.out.println("The next array elements are all of value 2 ");
    System.out.println(rslt);

    // uses the operator entry 
    ElwSqrt mySqrtOp = new ElwSqrt(data.getSpace()); 
    rslt = (Rsf) mySqrtOp.image(rslt); 

    float[][][] y = ((Rsf3) rslt).d;
    for(int i2=0; i2<nn[2]; i2++) {
    for(int i1=0; i1<nn[1]; i1++) {
    for(int i0=0; i0<nn[0]; i0++) {
      if (y[i2][i1][i0] != (float) Math.sqrt(2.f)) correct = false;
    }}}

    System.out.println("The next array elements are all about 1.41421");
    System.out.println(rslt);

    Tester.exit(correct);
  }
}

