package   rsf.operator;

import 	  rsf.vector.*;
import  juice.util.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ProjectionTest {
  public static void main(String[] args) {

    boolean correct = true;

    Rsf lne = RsfFactory.newRsf(5);    int[] lneIndex = {1};
    Rsf vol = RsfFactory.newRsf(3,4);  int[] volIndex = {1,1}; 
    //float[] steps = {1.f, 0.f}; 
    //Projection proj = new Projection((RsfSpace) vol.getSpace(), 
    //			     (RsfSpace) lne.getSpace(), steps);

    Projection proj = new Projection((RsfSpace) vol.getSpace(), 
				     (RsfSpace) lne.getSpace());
    proj.setNormal((float) (.0f * Math.PI));

    System.err.println("\n 0 degree projection \n");

    vol.fill(1.f);
    //System.err.println("The original input are 1s: " + vol);
    System.err.println("vol[1] approx 1.0: " + vol.getDatum(volIndex)); 
    if (vol.getDatum(volIndex) != 1.f) correct = false; 
    proj.image(vol, lne);  
    //System.err.println("The projection are 4s and 0s: " + lne);
    System.err.println("lne[1] approx 4.0: " + lne.getDatum(lneIndex)); 
    if (lne.getDatum(lneIndex) != 4.f) correct = false; 
    vol.zero();

    proj.adjoint().image(lne, vol);
    //System.err.println("The back-projection are 4s: " + vol); 
    System.err.println("vol[1] approx 4.0: " + vol.getDatum(volIndex)); 
    if (vol.getDatum(volIndex) != 4.f) correct = false; 

    vol.fill(1.f);
    //System.err.println("The original input are 1s: " + vol);
    System.err.println("vol[1] approx 1.0: " + vol.getDatum(volIndex)); 
    if (vol.getDatum(volIndex) != 1.f) correct = false; 
    proj.setWeights();
    proj.image(vol, lne);
    //System.err.println("The projection is 2's and 0's: " + lne);
    System.err.println("lne[1] approx 2.0: " + lne.getDatum(lneIndex));  
    if (lne.getDatum(lneIndex) != 2.f) correct = false; 
    vol.zero();
    proj.adjoint().image(lne, vol);
    //System.err.println("The back-projection is all 1's: " + vol); 
    System.err.println("vol[1] approx 1.0: " + vol.getDatum(volIndex)); 
    if (vol.getDatum(volIndex) != 1.f) correct = false; 

    System.err.println("\n 45 degree projection \n");

    //float[] steps45 = {1.f,1.f}; 
    //Projection proj45 = new Projection((RsfSpace) vol.getSpace(), 
    //			       (RsfSpace) lne.getSpace(), steps45);

    Projection proj45 = new Projection((RsfSpace) vol.getSpace(), 
				       (RsfSpace) lne.getSpace());
    proj45.setNormal((float) (Math.PI / 4.)); 

    vol.fill(1.f);
    //System.err.println("The original input are 1s: " + vol);
    System.err.println("vol[1] approx 1.0: " + vol.getDatum(volIndex)); 
    if (vol.getDatum(volIndex) != 1.f) correct = false; 
    proj45.image(vol, lne); 
    //System.err.println("The projection varies: " + lne);
    System.err.println("lne[1] approx 3.1715: " + lne.getDatum(lneIndex)); 
    if (lne.getDatum(lneIndex) < 3.1715f) correct = false; 
    if (lne.getDatum(lneIndex) > 3.1716f) correct = false; 
    vol.zero();
    proj45.adjoint().image(lne, vol);
    //System.err.println("The back-projection varies: " + vol); 
    System.err.println("vol[1] approx 3.606: " + vol.getDatum(volIndex)); 
    if (vol.getDatum(volIndex) < 3.606f) correct = false; 
    if (vol.getDatum(volIndex) > 3.607f) correct = false; 

    vol.fill(1.f);
    //System.err.println("The original input are 1s: " + vol);
    System.err.println("vol[1] approx 1.0: " + vol.getDatum(volIndex)); 
    if (vol.getDatum(volIndex) != 1.f) correct = false; 
    proj45.setWeights();
    proj45.image(vol, lne);
    //System.err.println("The projection varies: " + lne); 
    System.err.println("lne[1] approx 1.78089: " + lne.getDatum(lneIndex)); 
    if (lne.getDatum(lneIndex) < 1.7808f) correct = false; 
    if (lne.getDatum(lneIndex) > 1.7809f) correct = false; 
    vol.zero();
    proj45.adjoint().image(lne, vol);
    //System.err.println("The back-projection is all 1's: " + vol); 
    System.err.println("vol[1] approx 1.0: " + vol.getDatum(volIndex)); 
    //if (vol.getDatum(volIndex) != 1.f) correct = false; 

    System.out.println("A test with a square matrix"); 

    Rsf1 dia = (Rsf1) RsfFactory.newRsf(7);    
    Rsf2 sqr = (Rsf2) RsfFactory.newRsf(5,5);  

    System.out.println("The diagonal input is: 0,1,2,3,4,5,6");
    dia.d[0] = 0.f; dia.d[1] = 1.f; dia.d[2] = 2.f; 
    dia.d[3] = 3.f; dia.d[4] = 4.f; dia.d[5] = 5.f; dia.d[6] = 6.f;
    Projection projDia = new Projection((RsfSpace) sqr.getSpace(), 
					(RsfSpace) dia.getSpace());
    projDia.setNormal((float) (Math.PI / 4.)); 
    projDia.adjoint().image(dia,sqr);
    projDia.image(sqr,dia);
    System.out.println("The adjoint is obviously not the inverse: ");
    if (! Tester.isApprox("dia.d[0]",dia.d[0],0.414214f)) correct = false;
    if (! Tester.isApprox("dia.d[1]",dia.d[1],3.48528f))  correct = false;
    if (! Tester.isApprox("dia.d[2]",dia.d[2],11.6396f))  correct = false;
    if (! Tester.isApprox("dia.d[3]",dia.d[3],19.3137f))  correct = false;
    if (! Tester.isApprox("dia.d[4]",dia.d[4],17.7107f))  correct = false;
    if (! Tester.isApprox("dia.d[5]",dia.d[5],14.4315f))  correct = false;
    if (! Tester.isApprox("dia.d[6]",dia.d[6],3.71573f))  correct = false;

    projDia.setWeights(); 
    dia.d[0] = 0.f; dia.d[1] = 1.f; dia.d[2] = 2.f; 
    dia.d[3] = 3.f; dia.d[4] = 4.f; dia.d[5] = 5.f; dia.d[6] = 6.f;
    projDia.adjoint().image(dia,sqr);
    projDia.image(sqr,dia);
    System.out.println("But setting appropiate weights helps: ");
    if (! Tester.isApprox("dia.d[0]",dia.d[0],0.184699f)) correct = false;
    if (! Tester.isApprox("dia.d[1]",dia.d[1],0.984864f)) correct = false;
    if (! Tester.isApprox("dia.d[2]",dia.d[2],2.07351f )) correct = false;
    if (! Tester.isApprox("dia.d[3]",dia.d[3],3.1261f  )) correct = false;
    if (! Tester.isApprox("dia.d[4]",dia.d[4],3.98012f )) correct = false;
    if (! Tester.isApprox("dia.d[5]",dia.d[5],5.20659f )) correct = false;
    if (! Tester.isApprox("dia.d[6]",dia.d[6],4.74792f )) correct = false;

    System.err.println("\n 30 degree projection \n");

    //float[] steps30 = {1.f/3.f,1.f}; 
    //Projection proj30 = new Projection((RsfSpace) vol.getSpace(), 
    //			       (RsfSpace) lne.getSpace(), steps30);

    Projection proj30 = new Projection((RsfSpace) vol.getSpace(), 
				       (RsfSpace) lne.getSpace());
    proj30.setNormal((float) (Math.PI / 6.)); 

    vol.fill(1.f);
    //System.err.println("The original input are 1s: " + vol);
    System.err.println("vol[1] approx 1.0: " + vol.getDatum(volIndex)); 
    if (vol.getDatum(volIndex) != 1.f) correct = false; 
    proj30.image(vol, lne); 
    //System.err.println("The projection varies: " + lne);
    System.err.println("lne[1] approx 3.90192: " + lne.getDatum(lneIndex)); 
    if (!JuiceUtil.approx(lne.getDatum(lneIndex),3.90192f)) correct = false; 
    vol.zero();
    proj30.adjoint().image(lne, vol);
    //System.err.println("The back-projection varies: " + vol); 
    System.err.println("vol[1] approx 3.98686: " + vol.getDatum(volIndex)); 
    if (!JuiceUtil.approx(vol.getDatum(volIndex),3.98686f)) correct = false; 

    vol.fill(1.f);
    //System.err.println("The original input are 1s: " + vol);
    System.err.println("vol[1] approx 1.0: " + vol.getDatum(volIndex)); 
    if (vol.getDatum(volIndex) != 1.f) correct = false; 
    proj30.setWeights();
    proj30.image(vol, lne);
    //System.err.println("The projection varies: " + lne); 
    System.err.println("lne[1] approx 1.97533: " + lne.getDatum(lneIndex)); 
    if (!JuiceUtil.approx(lne.getDatum(lneIndex),1.97533f)) correct = false; 
    vol.zero();
    proj30.adjoint().image(lne, vol);
    //System.err.println("The back-projection is all 1's: " + vol); 
    System.err.println("vol[1] approx 1.0: " + vol.getDatum(volIndex)); 
    if (!JuiceUtil.approx(vol.getDatum(volIndex),1.0f)) correct = false; 

    System.err.println("\n 30 degree projection and random number \n");

    vol.rand(new java.util.Random(150398l));
    //System.err.println("The original input includes .441063: " + vol);
    System.err.println("vol[1] approx .441063: " + vol.getDatum(volIndex)); 
    if (!JuiceUtil.approx(vol.getDatum(volIndex),.441063f)) correct = false; 
    proj30.setWeights();
    proj30.image(vol, lne);
    //System.err.println("The projection varies: " + lne); 
    System.err.println("lne[1] approx .434258: " + lne.getDatum(lneIndex)); 
    if (!JuiceUtil.approx(lne.getDatum(lneIndex),.434258f)) correct = false; 

    vol.zero();
    proj30.adjoint().image(lne, vol);
    //System.err.println("The back-projection is .292571: " + vol); 
    System.err.println("vol[1] approx .292571: " + vol.getDatum(volIndex)); 
    if (!JuiceUtil.approx(vol.getDatum(volIndex),.292571f)) correct = false; 

    proj30.image(vol, lne);
    //System.err.println("The projection varies: " + lne); 
    System.err.println("lne[1] approx .35609: " + lne.getDatum(lneIndex)); 
    //if (!JuiceUtil.approx(lne.getDatum(lneIndex),.352609f)) correct = false; 
    vol.zero();
    proj30.adjoint().image(lne, vol);
    //System.err.println("The back-projection is .25639: " + vol); 
    System.err.println("vol[1] approx .25639: " + vol.getDatum(volIndex)); 
    // if (!JuiceUtil.approx(vol.getDatum(volIndex),.25639f)) correct = false; 

    Tester.exit(correct);
  }
}

   
