package  rsf.operator;

import   rsf.vector.*;
import   juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class SpikeTest {
  public static void main(String[] argv) {

    boolean correct = true;

    System.out.println("We create a Spiky data set with 12 samples");
    Rsf dat1 = RsfFactory.newRsf(12);
    Spike spiky1 = new Spike((RsfSpace) dat1.getSpace()); 

    int[] here = {1};
    System.out.println("We set a spike of 3 at the 2nd sample");
    spiky1.setSpike(here);
    spiky1.setMagnitude(3.f); 
    spiky1.addImage(dat1,dat1);

    if (dat1.getDatum(here) != 3.F) correct = false;
    System.out.println("Should be 3: " + dat1.getDatum(here));
    System.out.println(dat1); 

    Rsf dat3 = RsfFactory.newRsf(4,4,4); 
    Spike spiky3 = new Spike((RsfSpace) dat3.getSpace());

    int[] loc2   = {2, 2, 2}; // no spike added 
    int[] loc1   = {1, 1, 1}; //    spike added
    spiky3.setSpike(loc1); 
    spiky3.setMagnitude(33.3f); 
    spiky3.addImage(dat3,dat3); 

    if (dat3.getDatum(loc1) != 33.3f) correct = false;
    System.out.println("Should be 33.3: " + dat3.getDatum(loc1));
    if (dat3.getDatum(loc2) != 00.0f) correct = false;
    System.out.println("Should be 0   : " + dat3.getDatum(loc2));
    System.out.println(dat3); 

    System.out.println("Now we will test the main program.");
    String[] cmd = {"nsamples=3,2","out=junk.H",
		    "spike1=1,1","mag1=3.3f", 
		    "spike2=2,1","mag2=6.6f"}; 
    Spike.main(cmd); 
    Rsf data = RsfFactory.newRsf("junk.H");
    int[] indx1 = {1,1}; 
    int[] indx2 = {2,1}; 
    System.out.println("Should be 3.3: " + data.getDatum(indx1));
    System.out.println("Should be 6.6: " + data.getDatum(indx2));
    if (data.getDatum(indx1) != 3.3f) correct = false;
    if (data.getDatum(indx2) != 6.6f) correct = false;

    Tester.exit(correct);
  }
}

