package  rsf.operator;

import   jam.vector.*;
import juice.vector.*;
import 	 rsf.vector.*;
import   sep.io.ArgumentKeeper;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * Computes the mean of an input Rsf. All the elements of the 
 * output Rsf are constant value. Default Range is jag.juice.RealVec.
 */
public class StatMean implements jam.operator.Operator {
  RsfSpace domain;
  RsfSpace range;

  public StatMean(Space domain, Space range) {
    this.domain = (RsfSpace) domain;
    this.range  = (RsfSpace) range; 
  }
  public StatMean(Space domain) {
    this(domain, RealSpc.getSpace()); 
  }

  // operator superclass methods

  public jam.JamObject copy  () { return new StatMean(domain, range); }

  public Vector image(Vector d) {
    Vector r = getRange().newMember();
    statMean(false,r,d);
    return r;
  }
  public void image(Vector d, Vector r){
    statMean(false,r,d);
  }
  /** 
   * I wonder if this method makes any sense for Mean(). I could 
   * throw an error instead and get rid of the boolean add flag. 
   */
  public void addImage(Vector d, Vector r){ 
    statMean(true,r,d);
  } 
  public void residual(Vector d, Vector b, Vector r) {
    r.neg(b);
    addImage(d,r); 
  }

  public  Space getDomain         () { return domain; }
  public  Space getRange          () { return range ; }

  /**
   * Invocation: 
   * StatMean < i.H > o.H
   */
  public static void main(String[] args) { 
    Rsf data = RsfFactory.newRsf(System.in);
    data.fill(StatMean.statMean(data)); 
    data.write(System.out); 
  }

  public static void statMean(boolean add, Vector r, Vector d) {
    if (add) System.err.println("add flag not implemented!"); 
    if (d.getClass().getName().equals("RealVec")) 
      ((RealVec)r).setValue(statMean((Rsf) d));
    else 
      ((Rsf)    r).fill    (statMean((Rsf) d));
  }

  public static float statMean(Rsf d) {
    int[] dd = ((RsfSpace) d.getSpace()).getNSamples();
    float mean = 0.f; 

    switch (dd.length) {
    case 1: 
      float[] d0 = ((Rsf1) d).d;
      for (int i0=0; i0<dd[0]; i0++) {
	mean += d0[i0];
      }
      break;
    case 2: 
      float[][] d1 = ((Rsf2) d).d;
      for (int i1=0; i1<dd[1]; i1++) {
      for (int i0=0; i0<dd[0]; i0++) {
	mean += d1[i1][i0];
      }}
      break;
    case 3:
      float[][][] d2 = ((Rsf3) d).d;
      for (int i2=0; i2<dd[2]; i2++) {
      for (int i1=0; i1<dd[1]; i1++) {
      for (int i0=0; i0<dd[0]; i0++) {
	mean += d2[i2][i1][i0]; 
      }}}
      break;
    }
    mean = mean / d.size();
    return mean;
  }
}







