package  rsf.operator;

import   rsf.vector.*;
import   juice.util.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class StatVarTest {
  public static void main(String[] argv) {

    boolean correct = true;

    int[] dd = {2,3};
    Rsf data = RsfFactory.newRsf(dd);
    int[] rr = {3};
    Rsf rslt = RsfFactory.newRsf(rr);

    data.zero(); 
    data.fill(1.0f); 
    System.out.println(data);

    // uses the static routine 
    System.out.println("This should be 0: " + StatVar.statVar(data));
    if (StatVar.statVar(data) != 0.0f) correct = false;

    data.zero();
    int[] i0 = {0,0};
    data.setDatum(i0,3.0f);
    int[] i1 = {1,0};
    data.setDatum(i1,3.0f);
    System.out.println(data);

    // uses the static routine 
    System.out.println("This should be about 1.414: " + StatVar.statVar(data));
    if (!JuiceUtil.approx(StatVar.statVar(data),1.4142136f)) correct = false;

    data.zero();
    data.setDatum(i0,6.0f);
    System.out.println(data);

    // uses the static routine 
    System.out.println("This should be 2.236: " + StatVar.statVar(data));
    if (!JuiceUtil.approx(StatVar.statVar(data),2.236068f)) correct = false;

    // uses the operator entry 
    StatVar myVar = new StatVar(data.getSpace(),rslt.getSpace()); 
    myVar.image(data,rslt); 

    float[] y = ((Rsf1) rslt).d;
    for(int i=0; i<rr[0]; i++) {
      if (!JuiceUtil.approx(y[i],2.236068f)) correct = false;
    }

    System.out.println("The next array elements are all of value 5 ");
    System.out.println(rslt);

    data.rand();
    myVar.image(data,rslt); 
    
    System.out.println("This should be random: ");
    System.out.println(data);
    data.write("junkStatVar.H"); 

    System.out.println("This should be a 3 element Rsf filled with variance:");
    System.out.println(rslt);

    Tester.exit(correct);
  }
}

