package  rsf.util;

import   rsf.vector.*;
import juice.util.JuiceUtil;
import  java.io.DataInputStream;
import  java.io.IOException;
import   sep.io.*;

/**
 * Needs to be generalized to other dataTypes
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class Attr {
  boolean evaluated;
  Rsf     rsfIput  ;
  double mean  = 0.;
  double norm  = 0.;
  double nrm2  = 0.;
  double rms   = 0.;
  int    numZ  = 0 ;
  int[]  max, min  ; 
  float  maxV,minV ;
  int    maxC,minC ;
  int    num       ;
  public Attr(Rsf rsfIput) { 
    this.rsfIput = rsfIput; 
    num = rsfIput.size();
    max = new int[rsfIput.getDimension()];
    min = new int[rsfIput.getDimension()];
  }
  void evaluate() {
    if (evaluated == false) {
      int[] rr = ((RsfSpace) rsfIput.getSpace()).getNSamples();
      switch (rr.length) {
      case 1:
	evaluate1D();
	break; 
      case 2:
	evaluate2D();
	break;
      case 3:
	evaluate3D();
	break;
      default:
	System.err.println("not implemented yet");
      }
      mean = mean / rsfIput.size();
      rms  = Math.sqrt(nrm2 / rsfIput.size());
      norm = Math.sqrt(nrm2);
      evaluated = true;
    }
  }
  
  void evaluate1D() {
    int[]   rr = ((RsfSpace) rsfIput.getSpace()).getNSamples();
    float[] r0 = ((Rsf1) rsfIput).d;
    maxV = r0[0]; maxC = 1;
    minV = r0[0]; minC = 1; 
    int counter = 1; 
    for (int i0=0; i0<rr[0]; i0++) {
      mean += r0[i0];
      nrm2 += r0[i0] * r0[i0];
      if (r0[i0] != 0) numZ++;
      if (r0[i0] > maxV) {
	maxV = r0[i0];
	maxC = counter; 
	max[0] = i0;
      }
      if (r0[i0] < minV) {
	minV = r0[i0];
	minC = counter;
	min[0] = i0;
      }      
      counter++;
    }
  }

  void evaluate2D() {
    int[]   rr = ((RsfSpace) rsfIput.getSpace()).getNSamples();
    float[][]   r1 = ((Rsf2) rsfIput).d;
    maxV = r1[0][0]; maxC = 1;
    minV = r1[0][0]; minC = 1;
    int counter = 1; 
    for (int i1=0; i1<rr[1]; i1++) {
    for (int i0=0; i0<rr[0]; i0++) {
      mean += r1[i1][i0];
      nrm2 += r1[i1][i0] * r1[i1][i0];
      if (r1[i1][i0] != 0) numZ++;
      if (r1[i1][i0] > maxV) {
	maxV = r1[i1][i0];
	maxC = counter; 
	max[0] = i0; 
	max[1] = i1;
      }
      if (r1[i1][i0] < minV) {
	minV = r1[i1][i0];
	minC = counter;
	min[0] = i0;
	min[1] = i1;
      }
      counter++;
    }}
  }
  
  void evaluate3D() {
    int[]   rr = ((RsfSpace) rsfIput.getSpace()).getNSamples();
    float[][][] r2 = ((Rsf3) rsfIput).d;
    maxV = r2[0][0][0]; maxC = 1;
    minV = r2[0][0][0]; minC = 1;
    int counter = 1; 
    for (int i2=0; i2<rr[2]; i2++) {
    for (int i1=0; i1<rr[1]; i1++) {
    for (int i0=0; i0<rr[0]; i0++) {
      mean += r2[i2][i1][i0];
      nrm2 += r2[i2][i1][i0] * r2[i2][i1][i0];
      if (r2[i2][i1][i0] != 0) numZ++;
      if (r2[i2][i1][i0] > maxV) {
	maxV = r2[i2][i1][i0];
	maxC = counter; 
	max[0] = i0;
	max[1] = i1;
	max[2] = i2;
      }
      if (r2[i2][i1][i0] < minV) {
	minV = r2[i2][i1][i0];
	minC = counter;
	min[0] = i0;
	min[1] = i1;
	min[2] = i2;
      } 
      counter++; 
    }}}
  }

  public float getMax() {
    evaluate();
    return (float) maxV;
  }
  public float getMin() {
    evaluate();
    return (float) minV;
  }
  public float getAbsMax() {
    evaluate();
    return (Math.abs(maxV) > Math.abs(minV)) ? 
      (float) Math.abs(maxV) : (float) Math.abs(minV) ;
  }
  public float getNorm() {
    evaluate();
    return (float) norm;
  }
  public float getMean() {
    evaluate();
    return (float) mean;
  }
  public float getRms() {
    evaluate();
    return (float) rms;
  }

  public String toString() {
    // create the results
    evaluate();
    StringBuffer results = new StringBuffer(300);
    int[] indices = new int[rsfIput.getDimension()];
    results.append("mean value = ").append(mean).append("\n");
    results.append("rms  value = ").append(rms).append("\n");
    results.append("norm value = ").append(norm).append("\n");
    results.append("maximum value = ").append(rsfIput.getDatum(max)).append(" at ");
    results.append(" at ").append(maxC).append(" (");
    //results.append(JuiceUtil.arrayToString(rsfIput.getIndices(max), " "));
    for(int i=0; i< rsfIput.getDimension()-1; i++) {
      results.append(max[i]).append(", ");
    } 
    results.append(max[rsfIput.getDimension()-1]);
    results.append(")").append("\n");
    results.append("minimum value = ").append(rsfIput.getDatum(min)).append(" at ");
    results.append(" at ").append(minC).append(" (");
    //results.append(JuiceUtil.arrayToString(rsfIput.getIndices(min), " "));
    for(int i=0; i< rsfIput.getDimension()-1; i++) {
      results.append(min[i]).append(", ");
    } 
    results.append(min[rsfIput.getDimension()-1]);
    results.append(")").append("\n");
    results.append("number of nonzero samples = ").append(numZ).append("\n");
    results.append("number of samples = ").append(num);

    return results.toString();
  }

  /** 
   * Attr < input.H \br
   * Attr computes some statistics of a given SEP set, input.H.
   */
  public static void main(String[] args) {
    Rsf myData = RsfFactory.newRsf(System.in);
    Attr attributes = new Attr(myData); 
    System.out.println(attributes);
  }
}

    


