package  rsf.util;

import   rsf.vector.*;
import   juice.util.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class AttrTest {
  public static void main(String[] argv) {

    boolean correct = true;

    int[] nn = {5,3,2};
    Rsf data = RsfFactory.newRsf(nn);
    java.util.Random randomizer = new java.util.Random(813504);
    data.rand(randomizer); 

    Attr rand = new Attr(data);
    System.out.println("Does that look reasonable?\n");
    System.out.println(data);
    System.out.println(rand);
    data.write("rand.H");

    if(! JuiceUtil.approx(rand.getMean(),  -.04773f)) correct = false;
    if(! JuiceUtil.approx(rand.getRms(),    .52605f)) correct = false;
    if(! JuiceUtil.approx(rand.getMax(),    .88864f)) correct = false;
    if(! JuiceUtil.approx(rand.getMin(),   -.93606f)) correct = false;
    if(! JuiceUtil.approx(rand.getAbsMax(), .93605f)) correct = false;
    if(! JuiceUtil.approx(rand.getNorm(),  2.8813f )) correct = false;

    data.fill(9.0f);
    Attr nine = new Attr(data);
    System.out.println(data);
    System.out.println(nine);
    data.write("nine.H");

    if (nine.getMean  () != 9.f) correct = false; 
    if (nine.getRms   () != 9.f) correct = false; 
    if (nine.getMax   () != 9.f) correct = false; 
    if (nine.getMin   () != 9.f) correct = false; 
    if (nine.getAbsMax() != 9.f) correct = false; 
    if (nine.getNorm  () < 49.29 || nine.getNorm() > 49.30 ) correct = false; 

    Tester.exit(correct);
  }
}

