package rsf.util;

import jam.vector.*;
import juice.operator.*;
import rsf.vector.*;
import sep.io.*;
import conv.convc.*; 
/**
 * This is a simple helper class when the general convolution stuff is 
 * overkill. I use it for smoothing.<br> 
 * <tt>Convolver.convolve(new Box.newRsf(3,3),myinput);</tt>
 * Cut-off boundary conditions. Maybe "folding back" boundary are better? 
 * convolveTransient() convolveInternal() convolveFoldBack() etc;
 */ 
public class Convolver { 
  /** 
   * depracated: return is easily forgotten: I prefer
   * to have convolve overwrite the input data. No return!
   */
  public static Rsf convolve(Rsf filter, Rsf data) {
    Ccai conv = new CcaiFactory(filter).
      getCcaiFromInputSpace((RsfSpace) data.getSpace());
    return (Rsf) conv.image(data); 
  }
  /** 
   * Usage: Convolver filter=filename.H 
   *                  [in=input.H | < input.H] [out=output.H | > output.H]
   */
  public static void main(String[] args) {
    Rsf iput   = null;
    Rsf filter = null;
    ArgumentKeeper argKeeper = new ArgumentKeeper(args);
    if (argKeeper.containsKey("filter")) {
      filter = RsfFactory.newRsf(argKeeper.getString("filter"));
    }  
    else {
      System.err.println("Error: needs filter argument.");
    }
    if (argKeeper.containsKey("in")) {
      iput = RsfFactory.newRsf(argKeeper.getString("in"));
    }  
    else {
      iput   = RsfFactory.newRsf(System.in); 
    }
    Rsf oput = Convolver.convolve(filter, iput);
     if (argKeeper.containsKey("out")) {
      oput.write(argKeeper.getString("out"));
    }  
    else {
      oput.write(System.out); 
    }
  }
}

