package  rsf.util;

import   rsf.vector.*;
import   juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class LapGeneralTest {
  public static void main(String[] argv) {

    boolean correct = true;

    System.out.println("We create a 1-D Generalized Laplacian filter");
    String[] args1 = {"file=junk.H","bigFilt=5","smlFilt=2"}; 
    LapGeneral.main(args1); 
    Rsf lap1 = RsfFactory.newRsf("junk.H"); 

    System.out.println(lap1);

    float eps = 1.e-7F;  
    int[] loc1 = {4};
    if (lap1.getDatum(loc1) >=  0.3F + eps) correct = false;
    if (lap1.getDatum(loc1) <=  0.3F - eps) correct = false;
    int[] loc2 = {0};
    if (lap1.getDatum(loc2) >=  -0.04F + eps) correct = false;
    if (lap1.getDatum(loc2) <=  -0.04F - eps) correct = false;

    System.out.println("We create a 3-D Generalized Laplacian filter");
    int[] nbg  = {7,5,5}; 
    Rsf big3 = RsfFactory.newRsf(nbg);
    int[] sml  = {5,3,3}; 
    Rsf sml3 = RsfFactory.newRsf(sml);

    LapGeneral.getLapGeneral(big3,sml3);

    int[] loc5 = {4,4,4}; 
    if (big3.getDatum(loc5) >=  -0.00231481F + eps) correct = false;
    if (big3.getDatum(loc5) <=  -0.00231481F - eps) correct = false;
    int[] loc6 = {0,0,0};
    if (big3.getDatum(loc6) >= -0.000771605F + eps) correct = false;
    if (big3.getDatum(loc6) <= -0.000771605F - eps) correct = false;

    System.out.println(big3);
    big3.write("junky.H");
    Tester.exit(correct);
  }
}

