package  rsf.util;

import   rsf.vector.*;
import   juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class LaplacianTest {
  public static void main(String[] argv) {

    boolean correct = true;

    System.out.println("We create a 2-D Laplacian filter");
    String[] args2 = {"dim=2","file=junk2.H"};
    Laplacian.main(args2); 
    Rsf lap2 = RsfFactory.newRsf("junk2.H"); 

    int[] loc21 = {1, 1};
    if (lap2.getDatum(loc21) != -4.F) correct = false;
    int[] loc22 = {0, 1};
    if (lap2.getDatum(loc22) !=  1.F) correct = false;
    int[] loc23 = {0, 0};
    if (lap2.getDatum(loc23) !=  0.F) correct = false;
    System.out.println(lap2.toString());

    System.out.println("We create a 3-D Laplacian filter");
    String[] args3 = {"file=junk3.H"};
    Laplacian.main(args3); 
    Rsf lap3 = RsfFactory.newRsf("junk3.H"); 

    int[] loc31 = {1, 1, 1};
    if (lap3.getDatum(loc31) != -6.F) correct = false;
    int[] loc32 = {0, 1, 1};
    if (lap3.getDatum(loc32) !=  1.F) correct = false;
    int[] loc33 = {0, 0, 0};
    if (lap3.getDatum(loc33) !=  0.F) correct = false;
    System.out.println(lap3.toString());

    Tester.exit(correct);
  }
}

