package  rsf.util;

import   rsf.vector.*;
import   juice.util.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class RickerTest {
  public static void main(String[] argv) {

    boolean correct = true;

    System.out.println("We create a 1-D Ricker filter");
    String[] args1 = {"file=junk1.H","nsamples=9"};
    Ricker.main(args1); 

    Rsf ricker1 = RsfFactory.newRsf("junk1.H"); 
    //System.out.println(ricker1.toString());
    System.out.println("To view it: Graph < ricker1.H | Tube");
    ricker1.write("ricker1.H");

    float eps = 1.e-7F;  
    int[] loc1 = {4};
    if (!JuiceUtil.approx(ricker1.getDatum(loc1),0.7881539f,eps)) 
      correct = false;
    int[] loc2 = {0};
    if (!JuiceUtil.approx(ricker1.getDatum(loc2),-0.033310056f,eps)) 
      correct = false;

    System.out.println("We create a 2-D Ricker filter");
    String[] args2 = {"file=junk2.H","nsamples=9,15"};
    Ricker.main(args2); 
    Rsf ricker2 = RsfFactory.newRsf("junk2.H"); 
    //System.out.println(ricker2.toString());
    System.out.println("To view it: Grey < ricker2.H | Tube");
    ricker2.write("ricker2.H");

    System.err.println("I read the test numbers from what seemed to be " +
		       "a reasonable output. Better check later");
    int[] loc3 = {4,2}; 
    System.err.println("loc3: " + ricker2.getDatum(loc3));
    if (!JuiceUtil.approx(ricker2.getDatum(loc3),-0.08611643f,eps)) 
      correct = false;
    int[] loc4 = {0,0};
    System.err.println("loc4: " + ricker2.getDatum(loc4));
    if (!JuiceUtil.approx(ricker2.getDatum(loc4),-8.225907E-5f,eps)) 
      correct = false;

    System.out.println("We create a 3-D Ricker filter");
    String[] args3 = {"file=junk3.H","nsamples=7,5,3"};
    Ricker.main(args3); 
    Rsf ricker3 = RsfFactory.newRsf("junk3.H"); 
    //System.out.println(ricker3.toString());
    System.out.println("To view it: Grey < ricker3.H | Tube");
    ricker3.write("ricker3.H");

    int[] loc5 = {3,2,1}; 
    System.err.println("loc5: " + ricker3.getDatum(loc5));
    if (!JuiceUtil.approx(ricker3.getDatum(loc5),0.5861909f,eps)) 
      correct = false;
    int[] loc6 = {0,0,0};
    System.err.println("loc6: " + ricker3.getDatum(loc6));
    if (!JuiceUtil.approx(ricker3.getDatum(loc6),-4.9342736E-5f,eps)) 
      correct = false;

    Tester.exit(correct);
  }
}

