package  rsf.util;

import   rsf.vector.*;
import   juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class TentTest {
  public static void main(String[] argv) {

    boolean correct = true;

    System.out.println("We create a 1-D Tent filter");
    String[] args1 = {"file=junk1.H","nsamples=9"};
    Tent.main(args1); 
    Rsf tent1 = RsfFactory.newRsf("junk1.H"); 

    System.out.println(tent1.toString());

    float eps = 1.e-7F;  
    int[] loc1 = {4};
    if (tent1.getDatum(loc1) != 0.2F) correct = false;
    int[] loc2 = {0};
    if (tent1.getDatum(loc2) >= 0.04F + eps) correct = false;
    if (tent1.getDatum(loc2) <= 0.04F - eps) correct = false;

    System.out.println("We create a 2-D Tent filter");
    String[] args2 = {"file=junk2.H","nsamples=9,5"};
    Tent.main(args2); 
    Rsf tent2 = RsfFactory.newRsf("junk2.H"); 

    int[] loc3 = {4,2}; 
    if (tent2.getDatum(loc3) <= 0.06666F) correct = false;
    if (tent2.getDatum(loc3) >= 0.06667F) correct = false;
    int[] loc4 = {0,0};
    if (tent2.getDatum(loc4) <= 0.00444F) correct = false;
    if (tent2.getDatum(loc4) >= 0.00445F) correct = false;
    System.out.println(tent2.toString());

    System.out.println("We create a 3-D Tent filter");
    String[] args3 = {"file=junk3.H","nsamples=7,5,3"};
    Tent.main(args3); 
    Rsf tent3 = RsfFactory.newRsf("junk3.H"); 

    int[] loc5 = {3,2,1}; 
    System.err.println("......" + tent3.getDatum(loc5));
    if (tent3.getDatum(loc5) <=  0.04166F) correct = false;
    if (tent3.getDatum(loc5) >=  0.04167F) correct = false;
    int[] loc6 = {0,0,0};
    System.err.println("......" + tent3.getDatum(loc6));
    if (tent3.getDatum(loc6) <= 0.0017361F) correct = false;
    if (tent3.getDatum(loc6) >= 0.0017362F) correct = false;
    System.out.println(tent3.toString());

    Tester.exit(correct);
  }
}

