package rsf.vector;

import  jam.vector.*;
import  jam.JamObject;

/**
 * Axis specification for a regularly sampled function.
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * @author    Joel Schroeder
 */

public class Axis implements JamObject {

  /** depreciated: should be nSamples. change it! */
  public int    nsamples ; 
  public float  delta    ;
  public float  offset   ;
  public String label    ;
  public String unit     ; 
  
  public Axis(int nsamples,  float delta, float offset,
	      String label, String unit ) {
    this.nsamples = nsamples;
    this.delta    = delta;
    this.offset   = offset;
    this.label    = label;
    this.unit     = unit;
  }
  
  public Axis(int nsamples ) {
    this.nsamples = nsamples;
    this.delta    = 1f;
    this.offset   = 0f;
    this.label    = "";
    this.unit     = "";
  }
  
  /** copy constructor */
  public Axis(Axis src) {
    this.nsamples = src.nsamples;
    this.delta    = src.delta;
    this.offset   = src.offset;
    this.label    = src.label;
    this.unit     = src.unit;
  }

  public JamObject copy() { return new Axis(this); }
  
  public boolean equals(Object ax2) {
    if (this == ax2) return true;
    if (!(ax2 instanceof Axis)) return false;
    if   (this.nsamples !=  ((Axis) ax2).nsamples) return false;
    if   (this.delta    !=  ((Axis) ax2).delta   ) return false;
    if   (this.offset   !=  ((Axis) ax2).offset  ) return false;
    if (!(this.label.equals(((Axis) ax2).label ))) return false;
    if (!(this.unit .equals(((Axis) ax2).unit  ))) return false;
    return true;
  }
  
  public String toString() {
    return ("nsamples: " + nsamples + "  " +
	    "delta: "    + delta    + "  " +
	    "offset: "   + offset   + "  " +
	    "label: "    + label    + "  " +
	    "unit: "     + unit            );
  }
}
