package rsf.vector;

import  jam.vector.*;
import  jam.JamObject;

/**
 * Axis specification for a regularly sampled function.
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * @author    Joel Schroeder
 */

public class DataAxis implements JamObject {
  public String label    ;
  public String unit     ; 
  
  public DataAxis(String label, String unit ) {
    this.label    = label;
    this.unit     = unit;
  }
  
  public DataAxis() {
    this.label    = "amplitude";
    this.unit     = "unitless";
  }
  
  /** copy constructor */
  public DataAxis(DataAxis src) {
    this.label    = src.label;
    this.unit     = src.unit;
  }

  public JamObject copy() { return new DataAxis(this); }
  
  public boolean equals(Object ax2) {
    if (this == ax2) return true;
    if (!(ax2 instanceof      DataAxis))               return false;
    if (!(this.label.equals(((DataAxis) ax2).label ))) return false;
    if (!(this.unit .equals(((DataAxis) ax2).unit  ))) return false;
    return true;
  }
  
  public String toString() {
    return ("label: " + label    + "  " +
	    "unit: "  + unit            );
}
}

