package rsf.vector;

import   jam.vector.*;
import juice.util.JuiceUtil;
import juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */

public class RsfTest extends juice.util.Tester {
  public static void main(String[] args) {
    System.out.println("RSF TEST\n--------\n");
    boolean passed = true;
    
    Axis[] ax = new Axis[3];
    ax[0] = new Axis(2, 1f, 0f, "time", "s" );
    ax[1] = new Axis(3, 2f, 0f, "distance", "m" );
    ax[2] = new Axis(5, 2f, 0f, "distance", "km" );
    
    // create junk.H from scratch
    Rsf rOrig = RsfFactory.newRsf(ax);
    String title = new String("Filltest"); 
    rOrig.setTitle(title); 
    rOrig.fill(2);
    rOrig.write("junk.H");
    
    // test reading and writing
    Rsf r = RsfFactory.newRsf("junk.H");
    if (! title.equals(r.getTitle())) passed = false;
    System.out.println(r );
    r.write("junk2.H");
    
    Rsf rsfRand = RsfFactory.newRsf(ax);
    rsfRand.rand();
    Rsf rsfZero = RsfFactory.newRsf((RsfSpace) rsfRand.getSpace());
    rsfZero.zero();
    Rsf rsfFill = RsfFactory.newRsf(rsfRand);
    rsfFill.fill(1);
    
    ax[0].label = "changed label";
    
    System.out.println(" The following should be a random vector:"); 
    System.out.println(rsfRand );
    System.out.println(" The following should be the zero vector:");
    System.out.println(rsfZero );
    System.out.println(" The following should be the \"one\" vector:");
    System.out.println(rsfFill );
    
    rsfZero.fill(1f);
    passed &= rsfZero.equals(rsfFill);
    Tester.exit(passed);
  }
}

